unit NAObjFac;

interface

uses
  ActiveX, MtsObj, Mtx, ComObj, StdVcl;

type
  TNeutralAutoObjectFactory = class(TAutoObjectFactory)
  private
    FNeutralApartment: Boolean;
  public
    constructor Create(ComServer: TComServerObject; AutoClass: TAutoClass;
      const ClassID: TGUID; Instancing: TClassInstancing;
      ThreadingModel: TThreadingModel = tmSingle;
      ANeutralApartment: Boolean = False);
    procedure UpdateRegistry(Register: Boolean); override;
  end;


implementation

{ TNeutralAutoObjectFactory }

constructor TNeutralAutoObjectFactory.Create(ComServer: TComServerObject;
  AutoClass: TAutoClass; const ClassID: TGUID;
  Instancing: TClassInstancing; ThreadingModel: TThreadingModel;
  ANeutralApartment: Boolean);
begin
  inherited Create(ComServer, AutoClass, ClassID, Instancing, ThreadingModel);
  FNeutralApartment := ANeutralApartment;
end;

procedure TNeutralAutoObjectFactory.UpdateRegistry(Register: Boolean);
var
  sClassID, sServerKeyName: string;
begin
  inherited UpdateRegistry(Register);
  if Register and FNeutralApartment then
  begin
    if Instancing = ciInternal then
      Exit;
    sClassID := GUIDToString(ClassID);
    sServerKeyName := 'CLSID\' + sClassID + '\' + ComServer.ServerKey;
    if (ThreadingModel <> tmSingle) and IsLibrary then
      CreateRegKey(sServerKeyName, 'ThreadingModel', 'Neutral');
  end;
end;


end.
